namespace org.openxma.dsl.reference.ui.layouting

import org.openxma.dsl.reference.*

component xma::Layouting {
	
    data Customer customer1
	data Customer customer2    
	data Customer customer3	

    page LayoutingPage {                
        content {
        	tabfolder top=0 bottom=100% {
        		tabpage absoluteAttachment "Absolute attachment" {
        			panel "Simple panel" right=50%-2 margin=0 spacing=0 {
		    			text t1a left=10 top=10 right=200
						text t1b left=10 right=200		    			
		    			text t1c left=10 width=180
						text t1d left=200 right=100%		    			
		    			customer1.firstName left=10 right=200
						customer1.lastName left=10 width=180		    			
        			}
        			vpanel "Simple vpanel" top=0 bottom=previous.bottom left=50%+2 right=100% {
		    			text t2a left=10 top=10 right=200
						text t2b left=10 right=200		    			
		    			text t2c left=10 width=180
						text t2d left=10 width=360 right=200		    			
		    			customer2.firstName left=10 right=200
						customer2.lastName left=10 width=180		    			
        			}
        			hpanel "Simple hpanel1" top=previous {
		    			text t3a left=10 top=10 right=200
						text t3b left=10 right=200		    			
		    			text t3c left=10 width=180
        			}
          			hpanel "Simple hpanel2" top=previous {
						text t3d left=10 width=360 right=200		    			
        			}  
          			hpanel "Simple hpanel3" top=previous {		    			
		    			customer3.firstName left=10 right=200
						customer3.lastName left=10 width=180		    			
        			}         			
        		}        		
        		tabpage relativeAttachment "Relative attachment" {
        			panel "Simple panel" right=50%-2 {
		    			text t1a left=5% top=5% right=70%
						text t1b left=5% right=70%		    			
		    			text t1c left=5%+10 right=70%
						text t1d left=5%+10 right=70%+10		    			
		    			customer1.firstName left=5%-10 right=70%+10		    			
        			}
        			vpanel "Not scrollable panel" left=50%+2 top=0 {
						text t2b left=5% right=90%		    			
		    			text t2c left=5% width=10 right=90%
        			}
        			vpanel "Scrollable panel 1" left=50%+2 top=previous scrollable=true {
						text t3a left=5% width=40		    			
						text t3b left=5% width=40 right=90%						
		    			text t3c left=5% right=90%
        			}
        			vpanel "Scrollable panel 2 (small)" left=50%+2 top=previous scrollable=true {
						text t4a left=5% width=40        				
						text t4b left=5% width=40 right=90%		    			
        			}
        			vpanel "Scrollable panel 2 (large)" left=50%+2 top=previous scrollable=true {
						text t5a left=5% width=300        				
						text t5b left=5% width=300 right=90%		    			
        			}           			          			           			        			
        		}
        		tabpage tabulatorAttachment "Absolute attachment combined" {
        			panel "Simple panel" right=50%-2 {
		    			text t1a left=2char top=2char right=10char
						text t1b left=2char right=70	    			
		    			text t1c left=2char+10 right=100%-7
						text t1d left=24 right=100%-1char
						text t1e left=24 right=100%-1char-20						
						text t1f left=10%+2char right=100%-27						
						text t1g left=10%+1char+7 right=100%-1char-20
						text t1h left=10%+3char-7 right=100%-4char+2												
        			}        			
        		}
				tabpage absoluteCharAttachment "Tabulator attachment" {
					vpanel "" tabulator=14,10char,11char-7,9char+7,tbx:50%,50%+14,50%+2char,50%+1char+7,50%+3char-7 {
		    			text t1a left=14 right=70
						text t1b left=tab(1) right=tab(2)
						text t1c left=tab(1) right=tab(3)
						text t1d left=tab(1) right=tab(4) 
						text t1e left=tab(1) right=tab(5)
						text t1f left=tab(1) right=tab(6)
						text t1g left=tab(1) right=tab(7)						
						text t1h left=tab(1) right=tab(8)
						text t1i left=tab(1) right=tab(9)
						text t1j left=tab(1) right=tab(5)+14																						
						text t1k left=tab(1) right=tab(5)+1char+7						
						text t1l left=tab(1) right=tab(5)+3char-7						
						text t1m left=tab(1) right=tab(5)-1char+21						
						text t1n left=tab(1) right=tbx-1char+21						
					}
				}
				tabpage siblingAttachment "Sibling attachment" {
					panel {
						text t1a 
						text t1b right=t1a.right+14
						text t1c right=t1a.right+2char						
						text t1e right=t1a.right+1char+7
						text t1f right=t1a.right+3char-7	
						text t1g right=t1a.right-1char+21						
						text t1h right=t1a.right-1char+28 style=DoubleCharacterWidth						
					}	
				}
				tabpage fieldParts "Fieldparts" {
					vpanel {
						customer1.lastName[label left=0, control left=label.right+14]
						customer2.lastName[label left=0, control left=label.right+1char+7]						
					}					
				}        		
        	}
        }
    }
}

style DoubleCharacterWidth { 
	character-width: 14	
}