package org.openxma.dsl.reference.validation;

import org.springframework.validation.Errors;
import org.openxma.dsl.platform.validation.Validators;
import org.openxma.dsl.reference.model.Product;
import org.springframework.validation.ValidationUtils;

@SuppressWarnings("boxing")
public abstract class ProductGenValidator extends Validators {
    
    public boolean isNameRequired(Product product) {
        return Boolean.TRUE;
    }
    
    public boolean isUnitPriceRequired(Product product) {
        return Boolean.TRUE;
    }
    
    public boolean isSupplierRequired(Product product) {
        return Boolean.TRUE;
    }
    
    public boolean isCert1Required(Product product) {
        return Boolean.FALSE;
    }
    
    public boolean isCert2Required(Product product) {
        return Boolean.FALSE;
    }
    
    public boolean isCert3Required(Product product) {
        return Boolean.FALSE;
    }
        
    @SuppressWarnings("unchecked")
    public boolean supports(Class clazz) {
        return Product.class.isAssignableFrom(clazz);
    }
    
    public Errors validate(Product product) {
        Errors errors = createErrors(product);      
        validate(product,errors);
        return errors;
    }

    public void validate(Object object, Errors errors) {
        Product product = (Product) object;
        if (isNameRequired(product)) {
            ValidationUtils.rejectIfEmptyOrWhitespace(errors, "name", "field.required");
        }
        if (isUnitPriceRequired(product)) {
            ValidationUtils.rejectIfEmpty(errors, "unitPrice", "field.required");
        }
        if (isSupplierRequired(product)) {
            ValidationUtils.rejectIfEmpty(errors, "supplier", "field.required");
        }
        if (isCert1Required(product)) {
            ValidationUtils.rejectIfEmpty(errors, "cert1", "field.required");
        }
        if (isCert2Required(product)) {
            ValidationUtils.rejectIfEmpty(errors, "cert2", "field.required");
        }
        if (isCert3Required(product)) {
            ValidationUtils.rejectIfEmpty(errors, "cert3", "field.required");
        }
    }
    
}
