package org.openxma.dsl.reference.xma.customeredit.server;

import org.openxma.dsl.reference.dto.CustomerOrderView;
import org.openxma.dsl.reference.service.CustomerService;
import org.openxma.dsl.reference.service.OrderServiceFacade;
import org.springframework.beans.factory.annotation.Autowired;

import at.spardat.xma.component.ComponentServer;
import at.spardat.xma.rpc.RemoteCall;
import at.spardat.xma.rpc.RemoteReply;

/**
 * 
 * @author s5316
 */
public class CustomerEditForm extends CustomerEditFormGen {
	@Autowired
	private OrderServiceFacade orderServiceFacade;
	@Autowired
	private CustomerService customerService;

	/**
	 * Constructs the CustomerEditForm.
	 * 
	 * @param component
	 *            the component this page belongs to
	 */
	public CustomerEditForm(ComponentServer component) {
		super(component);
	}

	public void readCustomer(RemoteCall call, RemoteReply reply) {
		CustomerOrderView customerOrderView = orderServiceFacade.findByCustomerOid(getTypedComponent().getCustomer()
				.getOid());
		getTypedComponent().setOrders(customerOrderView.getOrders());
		page1.instanceDataToModel();
		page2.instanceDataToModel();
	}

	public void saveCustomer(RemoteCall call, RemoteReply reply) {
		page1.modelToInstanceData();
		customerService.update(getTypedComponent().getCustomer());
	}

	@Override
	public void cancel(RemoteCall call, RemoteReply reply) {
		// TODO Auto-generated method stub

	}

	@Override
	public void selectOrder(RemoteCall call, RemoteReply reply) {

	}

}
